<?php

namespace FiloBlu\EvaAttributes\Model;

class AttributeArray implements \Iterator {

    /**
     * @var mixed 
     */
    protected $attributes = [];

    /**
     * AttributeArray constructor.
     * @param null $attributes
     */
    public function __construct( $attributes = null ) {

        if($attributes === null) {
            return;
        }

        foreach($attributes as $k => $attribute)
        {
            if(!is_a($attribute, BaseAttribute::class))
            {continue;}

            $this->attributes[$k] = $attribute;
        }

    }

    /**
     * @return mixed|void
     */
    #[\ReturnTypeWillChange]
    function rewind() {
        return reset($this->attributes);
    }

    /**
     * @return mixed|array
     */
    #[\ReturnTypeWillChange]
    function current() {
        return current($this->attributes);
    }

    /**
     * @return int|mixed|string|null
     */
    #[\ReturnTypeWillChange]
    function key() {
        return key($this->attributes);
    }

    /**
     * @return mixed|void
     */
    #[\ReturnTypeWillChange]
    function next() {
        return next($this->attributes);
    }

    /**
     * @return bool
     */
    #[\ReturnTypeWillChange]
    function valid() {
        return key($this->attributes) !== null;
    }

}
